=== debian/changelog ===
bpftrace (0.14.0-1) unstable; urgency=medium

  * New upstream release.
  * d/control: build-depends on libcereal-dev.
  * d/control: build-depends on asciidoctor.
  * d/patches: remove patch to fix BEGIN/END_trigger. It does not work
    anymore.

 -- Vincent Bernat <bernat@debian.org>  Fri, 22 Oct 2021 23:34:48 +0200

bpftrace (0.13.0-2) unstable; urgency=medium

  * d/patches: add back patch to fix BEGIN/END_trigger (Closes: #995817)

 -- Vincent Bernat <bernat@debian.org>  Wed, 06 Oct 2021 15:50:57 +0200

bpftrace (0.13.0-1) unstable; urgency=medium

  * New upstream version. Closes: #995687.
  * d/patches: remove exported symbols, not needed anymore.

 -- Vincent Bernat <bernat@debian.org>  Mon, 04 Oct 2021 08:15:05 +0200
